#ifndef HASHEDSTRING_H
#define HASHEDSTRING_H

#include <unordered_map>

#include "common/utils/Types.h"

class HashedString {
public:
    HashedString(const char* str);
    
    bool operator==(const HashedString& other) const;
    bool operator!=(const HashedString& other) const;
    operator const char*() const;
    
    u32 hashCode() const;

private:
    static constexpr uint LENGTH = 32 - sizeof (u8) - sizeof (u32);
    char data[LENGTH];
    u8 length;
    u32 hash;
};

#endif